#ifndef GAMEOBJECTS_HPP_INCLUDED
#define GAMEOBJECTS_HPP_INCLUDED

#include "../../Game/Interactable/GameObject.hpp"
#include <functional>
#include <cstdint>
#include <vector>
#include <string>

namespace GameObjects
{
    std::vector<Interactable::GameObject> GetAllWithin(std::int32_t Distance);

    std::vector<Interactable::GameObject> GetAll();
    std::vector<Interactable::GameObject> GetAll(const Tile& T);
    std::vector<Interactable::GameObject> GetAll(std::int32_t ID, std::int32_t Distance = -1);
    std::vector<Interactable::GameObject> GetAll(const std::string& Name, std::int32_t Distance = -1);
    std::vector<Interactable::GameObject> GetAll(const std::vector<std::int32_t>& IDs, std::int32_t Distance = -1);
    std::vector<Interactable::GameObject> GetAll(const std::vector<std::string>& Names, std::int32_t Distance = -1);
    std::vector<Interactable::GameObject> GetAll(const std::function<bool (const Interactable::GameObject&)>& Filter, std::int32_t Distance = -1);

    Interactable::GameObject Get(const Tile& T);
    Interactable::GameObject Get(std::int32_t ID, std::int32_t Distance = -1);
    Interactable::GameObject Get(const std::string& Name, std::int32_t Distance = -1);
    Interactable::GameObject Get(const std::vector<std::int32_t>& IDs, std::int32_t Distance = -1);
    Interactable::GameObject Get(const std::vector<std::string>& Names, std::int32_t Distance = -1);
    Interactable::GameObject Get(const std::function<bool (const Interactable::GameObject&)>& Filter, std::int32_t Distance = -1);
}

#endif // GAMEOBJECTS_HPP_INCLUDED
